@probes=
	(
	"1_Bovine_GV_a_ATCACG",
	"2_Bovine_GV_b1_CGATGT",
	"4_Bovine_MI_1_TGACCA",
	"5_Bovine_MI_2_ACAGTG",
	"6_Bovine_MII_a1_GCCAAT",
	"7_Bovine_MII_a2_CCGTCC",
	"8_Bovine_MII_b1_GTAGAG",
	"9_Bovine_MII_b2_GATCAG",
	"10_Porcine_MII_1_TAGCTT",
	"11_Porcine_MII_2_GGCTAC",
	"12_Porcine_GV_1_CTTGTA",
	"13_Porcine_GV_2_AGTCAA",
	"14_Bovine_ovary_1_AGTTCC",
	"15_Bovine_ovary_2_ATGTCA",
	"16_Bovine_testis_1_CAGATC",
	"17_Bovine_testis_2_ACTTGA",
	"18_Porcine_ovary_1_GTCCGC",
	"19_Porcine_ovary_2_GTGAAA",
	"20_Porcine_testis_1_GTGGCC",
	"21_Porcine_testis_2_GTTTCG",
	"22_Macaque_ovary_1_CGTACG",
	"23_Macaque_ovary_2_GAGTGG",
	"24_Macaque_testis_1_GGTAGC",
	"25_Macaque_testis_2_TTAGGC",
	"26_Bovine-cumulus-MI-1",
	"27_Bovine-cumulus-MI-2",
	"28_bovine_cumulus_MII_1_TTAGGC",
	"29_bovine_cumulus_MII_2_TGACCA",
	"30_porcine_cumulus_GV_1_ACAGTG",
	"31_porcine_cumulus_GV_2_GCCAAT",
	"32_porcine_GV_1_CAGATC",
	"33_porcine_GV_2_ACTTGA",
	"34_bovine_oxidized_1_GATCAG",
	"35_bovine_oxidized_2_TAGCTT",
	"36_macaque_oxidized_1_GGCTAC",
	"37_macaque_oxidized_2_CTTGTA",
	"38_bovine_IVF_1_AGTCAA",
	"39_bovine_IVF_2_AGTTCC",
	"40_human_ovary_1_ATGTCA",
	"41_human_ovary_2_CCGTCC",
	"42_human_ovary_1_oxidized_GTAGAG",
	"43_human_ovary_2_oxidized_GTCCGC",
	"44_fetal_1st_1_GTGAAA",
	"45_fetal_1st_2_GTGGCC",
	"46_fetal_1st_1_oxidized_GTTTCG",
	"47_fetal_1st_2_oxidized_CGTACG",
	"48_fetal_2nd_1_GAGTGG",
	"49_fetal_2nd_2_GGTAGC",
	"50_fetal_2nd_1_oxidized_ATCACG",
	"51_fetal_2nd_2_oxidized_CGATGT"
	);

$|=1;
foreach$probe(@probes)
	{
	$pid=fork();
	if($pid) # parent
		{
		push(@childs,$pid);
		}
	elsif($pid==0) # child
		{
		if($probe=~/Bovine/i)
			{
			$RMfile='/home/rosenkrd/Desktop/RepeatMasker_4-0-2/Btau.genome.shorttitles.out';
			}
		elsif($probe=~/Porcine/i)
			{
			$RMfile='/home/rosenkrd/Desktop/RepeatMasker_4-0-2/Sscr.genome.shorttitles.out';
			}
		elsif($probe=~/Macaque/i)
			{
			$RMfile='/home/rosenkrd/Desktop/RepeatMasker_4-0-2/Mfas.genome.shorttitles.out';
			}
		elsif($probe=~/human/||$probe=~/fetal/)
			{
			$RMfile='/home/rosenkrd/Desktop/RepeatMasker_4-0-2/Hsap.genome.shorttitles.out';
			}
		
		print"\nStart processing $probe.";
		$map="$probe.passed.map";
		# read RepeatMasker file
		print"\nLoad RepeatMasker annotation to memory...";
		$i=0;
		%RM=();
		%te2class=();
		open(RM,$RMfile)||die print"\nCould not open RepeatMasker output $RMfile!\n$!\n";
		while(<RM>)
			{
			if($_=~s/^ *\d+ +//)
				{
				$i++;
				@rm=split(/ +/,$_);
				$te2class{$rm[8]}=$rm[9];
				$classes{$rm[9]}=1;
				$strand=1;
				if($rm[7]eq'C')
					{
					$strand=-1;
					}
				$RM{$rm[3]}{$rm[4]}=[$rm[5],$strand,$rm[8]]; # hash with key1 = chromosome / key2 = starting coordinate / value (=array) 0:end coordinate, 1:strand, 2:repeat
				}
			}
		close RM;
		print" done.\nReadout $i repeat elements.\n";
		# read map file to save reads and hits per sequence
		print"\nRead map file and save reads/hits...";
		$i=0;
		%reads=();
		%hits=();
		open(MAP,$map)||die print"\nCould not open map file $map!\n$!\n";
		while(<MAP>)
			{
			if($_!~/trans_id/)
				{
				$i++;
				$_=~s/\s*$//;
				@d=split("\t",$_);
				$reads{$d[4]}=$d[3];
				$hits{$d[4]}++;
				}
			}
		close MAP;
		$n_sequences=keys%reads;
		%normalized_hit_count=();
		foreach(keys%reads)
			{
			$normalized_hit_count{$_}=$reads{$_}/$hits{$_};
			$n_reads+=$reads{$_};
			}
		undef%reads;
		undef%hits;
		print" done.\n$i hits / $n_sequences sequences / $n_reads reads.\n";
		# read map file and compare hits with RepeatMasker annotation
		print"Compare sequence hits with RepeatMasker annotation...\n";
		$t0=time;
		$t1=time;
		$hit_id=0;
		%TEhits=();
		open(MAP,$map)||die print"\nCould not open map file $map!\n$!\n";
		while(<MAP>)
			{
			# do a time estimation
			$t2=time;
			if($t2-$t1>=30)
				{
				$remaining_time=int(((((1/($hit_id/$i))*($t2-$t0))-($t2-$t0))/60)+0.5);
				
				print"\b" x length$est;
				$est="hit: $hit_id ($i) est. remaining time: $remaining_time min.";
				print$est;
				
				$t1=time;
				}
			
			if($_!~/trans_id/)
				{
				$hit_id++;
				$_=~s/\s*$//;
				@d=split("\t",$_);
				
				# check if TE0-2 must change / determine TE0-2
				if($d[0]ne$prev_chr||$d[1]>$RM{$d[0]}{$TE1_start}[0])
					{
					$TE1_start=$d[1]+1;
					while($TE1_start>0)
						{
						# search the closest TE upstream =[1]
						$TE1_start=$TE1_start-1;
						if($RM{$d[0]}{$TE1_start})
							{
							# search the next TE upstream =[0]
							$TE0_start=$TE1_start;
							while($TE0_start>$TE1_start-10000)
								{
								$TE0_start=$TE0_start-1;
								if($RM{$d[0]}{$TE0_start})
									{
									last;
									}
								}
							# search the next TE downstream =[2]
							$TE2_start=$TE1_start;
							while($TE2_start<$TE1_start+10000)
								{
								$TE2_start++;
								if($RM{$d[0]}{$TE2_start})
									{
									last;
									}
								}
							last;
							}
						}	
					}
				
				# check whether each residue of the hit locus has a TE annotation (how many? which?)
				$complete_hit=1;
				$bin_string="";
				foreach$pos($d[1]..($d[1]+length$d[4])-1)
					{
					$bin=0;
					if($pos>=$TE0_start&&$pos<=$RM{$d[0]}{$TE0_start}[0])
						{
						$bin+=1;
						}
					if($pos>=$TE1_start&&$pos<=$RM{$d[0]}{$TE1_start}[0])
						{
						$bin+=2;
						}
					if($pos>=$TE2_start&&$pos<=$RM{$d[0]}{$TE2_start}[0])
						{
						$bin+=4;
						}
					if($bin==0)
						{
						$complete_hit=0;
						last;
						}
					else
						{
						$bin_string.=$bin;
						}
					}
				
				# count normalized reads for TE elements
				if($complete_hit==1)
					{
					$strand=1;
					if($d[6]eq'-')
						{
						$strand=-1;
						}
					
					# each residue of the hit locus has only one TE annotation
					if($bin_string=~/^2+$/)
						{
						$TEhits{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}+=$normalized_hit_count{$d[4]};
						
						# length distribution / basecomposition
						$lengthdistribution{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}+=$normalized_hit_count{$d[4]};
						foreach$pos(1..length$d[4])
							{
							$basecomposition{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=$normalized_hit_count{$d[4]};
							}
						}
					
					# more than one TE annotation for at least one residue of the hit
					else
						{
						$l=length$d[4];
						while($bin_string ne'')
							{
							$bin_string=~s/^.//;
							if($&==2)
								{
								$TEhits{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}+=$normalized_hit_count{$d[4]}/$l;
								
								# length distribution / basecomposition
								$lengthdistribution{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}+=$normalized_hit_count{$d[4]}/$l;
								foreach$pos(1..length$d[4])
									{
									$basecomposition{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=$normalized_hit_count{$d[4]}/$l;
									}
								}
							elsif($&==3)
								{
								$TEhits{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}+=($normalized_hit_count{$d[4]}/$l)/2;
								$TEhits{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}+=($normalized_hit_count{$d[4]}/$l)/2;
								
								# length distribution / basecomposition
								$lengthdistribution{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}{length$d[4]}+=($normalized_hit_count{$d[4]}/$l)/2;
								$lengthdistribution{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}+=($normalized_hit_count{$d[4]}/$l)/2;
								foreach$pos(1..length$d[4])
									{
									$basecomposition{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=($normalized_hit_count{$d[4]}/$l)/2;
									$basecomposition{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=($normalized_hit_count{$d[4]}/$l)/2;
									}
								}
							elsif($&==6)
								{
								$TEhits{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}+=($normalized_hit_count{$d[4]}/$l)/2;
								$TEhits{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}+=($normalized_hit_count{$d[4]}/$l)/2;
								
								# length distribution / basecomposition
								$lengthdistribution{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}+=($normalized_hit_count{$d[4]}/$l)/2;
								$lengthdistribution{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}{length$d[4]}+=($normalized_hit_count{$d[4]}/$l)/2;
								foreach$pos(1..length$d[4])
									{
									$basecomposition{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=($normalized_hit_count{$d[4]}/$l)/2;
									$basecomposition{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=($normalized_hit_count{$d[4]}/$l)/2;
									}
								}
							elsif($&==1)
								{
								$TEhits{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}+=$normalized_hit_count{$d[4]}/$l;
								
								# length distribution / basecomposition
								$lengthdistribution{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}{length$d[4]}+=$normalized_hit_count{$d[4]}/$l;
								foreach$pos(1..length$d[4])
									{
									$basecomposition{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=$normalized_hit_count{$d[4]}/$l;
									}
								}
							elsif($&==4)
								{
								$TEhits{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}+=$normalized_hit_count{$d[4]}/$l;
								
								# length distribution / basecomposition
								$lengthdistribution{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}{length$d[4]}+=$normalized_hit_count{$d[4]}/$l;
								foreach$pos(1..length$d[4])
									{
									$basecomposition{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=$normalized_hit_count{$d[4]}/$l;
									}
								}
							elsif($&==7)
								{
								$TEhits{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}+=($normalized_hit_count{$d[4]}/$l)/3;
								$TEhits{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}+=($normalized_hit_count{$d[4]}/$l)/3;
								$TEhits{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}+=($normalized_hit_count{$d[4]}/$l)/3;
								
								# length distribution / basecomposition
								$lengthdistribution{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}{length$d[4]}+=($normalized_hit_count{$d[4]}/$l)/3;
								$lengthdistribution{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}+=($normalized_hit_count{$d[4]}/$l)/3;
								$lengthdistribution{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}{length$d[4]}+=($normalized_hit_count{$d[4]}/$l)/3;
								foreach$pos(1..length$d[4])
									{
									$basecomposition{$RM{$d[0]}{$TE0_start}[2]}{$RM{$d[0]}{$TE0_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=($normalized_hit_count{$d[4]}/$l)/3;
									$basecomposition{$RM{$d[0]}{$TE1_start}[2]}{$RM{$d[0]}{$TE1_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=($normalized_hit_count{$d[4]}/$l)/3;
									$basecomposition{$RM{$d[0]}{$TE2_start}[2]}{$RM{$d[0]}{$TE2_start}[1]*$strand}{length$d[4]}{$pos}{substr$d[4],$pos-1,1}+=($normalized_hit_count{$d[4]}/$l)/3;
									}
								}
							}
						}
					}
				$prev_chr=$d[0];
				}
			}
		close MAP;
		# print results to outfile
		open(OUT,">$probe.repeat_counts")||die print"\nCould not create output file $probe.repeat_counts!\n$!\n";
		print OUT"TE\t+\t-\n";
		foreach$TE(keys%te2class)
			{
			unless($TEhits{$TE}{1})
				{
				$TEhits{$TE}{1}=0;
				}
			unless($TEhits{$TE}{-1})
				{
				$TEhits{$TE}{-1}=0;
				}
			$CLASShits{$te2class{$TE}}{1}+=$TEhits{$TE}{'1'};
			$CLASShits{$te2class{$TE}}{-1}+=$TEhits{$TE}{-1};
			$TEreads_sense+=$TEhits{$TE}{1};
			$TEreads_antisense+=$TEhits{$TE}{-1};
			print OUT"$TE\t$TEhits{$TE}{1}\t$TEhits{$TE}{-1}\n";
			}
		print OUT"\n";
		foreach$CLASS(keys%classes)
			{
			print OUT"$CLASS\t$CLASShits{$CLASS}{1}\t$CLASShits{$CLASS}{-1}\n";
			}
		print OUT"\nTotal TE reads sense: $TEreads_sense\nTotal TE reads antisense: $TEreads_antisense";
		close OUT;
		open(LENGTHDISTRIBUTION,">$probe.repeat_lengthdistr")||die print"\nCould not create $probe.repeat_lengthdistr\n$!\n";
		foreach$TE(keys%te2class)
			{
			print LENGTHDISTRIBUTION"### $TE ###\nlength\tsense\tantisense\n";
			foreach$l(18..34)
				{
				unless($lengthdistribution{$TE}{1}{$l})
					{
					$lengthdistribution{$TE}{1}{$l}=0;
					}
				unless($lengthdistribution{$TE}{-1}{$l})
					{
					$lengthdistribution{$TE}{-1}{$l}=0;
					}
				print LENGTHDISTRIBUTION"$l\t$lengthdistribution{$TE}{1}{$l}\t$lengthdistribution{$TE}{-1}{$l}\n";
				}
			print LENGTHDISTRIBUTION"\n";
			}
		close LENGTHDISTRIBUTION;
		open(BASECOMPOSITION,">$probe.repeat_basecomp")||die print"\nCould not create $probe.repeat_basecomp\n$!\n";
		foreach$TE(keys%te2class)
			{
			print BASECOMPOSITION"-" x 100;
			foreach$l(18..34)
				{
				print BASECOMPOSITION"\n### $TE-related $l nt reads ###\nPos.\tA+\tT+\tG+\tC+\tN+\t\tA-\tT-\tG-\tC-\tN-\n";
				foreach$pos(1..34)
					{
					foreach$nt('A','T','G','C','N')
						{
						unless($basecomposition{$TE}{1}{$l}{$pos}{$nt})
							{
							$basecomposition{$TE}{1}{$l}{$pos}{$nt}=0;
							}
						unless($basecomposition{$TE}{-1}{$l}{$pos}{$nt})
							{
							$basecomposition{$TE}{-1}{$l}{$pos}{$nt}=0;
							}
						}
					print BASECOMPOSITION"$pos\t$basecomposition{$TE}{1}{$l}{$pos}{A}\t$basecomposition{$TE}{1}{$l}{$pos}{T}\t$basecomposition{$TE}{1}{$l}{$pos}{G}\t$basecomposition{$TE}{1}{$l}{$pos}{C}\t$basecomposition{$TE}{1}{$l}{$pos}{N}\t\t$basecomposition{$TE}{-1}{$l}{$pos}{A}\t$basecomposition{$TE}{-1}{$l}{$pos}{T}\t$basecomposition{$TE}{-1}{$l}{$pos}{G}\t$basecomposition{$TE}{-1}{$l}{$pos}{C}\t$basecomposition{$TE}{-1}{$l}{$pos}{N}\n";
					}
				print BASECOMPOSITION"\n";
				}
			}
		close BASECOMPOSITION;
		
		exit 0;
		}
	else
		{
		die"could not fork: $!\n";
		}
	}
foreach(@childs)
	{
	$tmp=waitpid($_,0);
	}
