@probes=
	(
	"1_Bovine_GV_a_ATCACG",
	"2_Bovine_GV_b1_CGATGT",
	"4_Bovine_MI_1_TGACCA",
	"5_Bovine_MI_2_ACAGTG",
	"6_Bovine_MII_a1_GCCAAT",
	"7_Bovine_MII_a2_CCGTCC",
	"8_Bovine_MII_b1_GTAGAG",
	"9_Bovine_MII_b2_GATCAG",
	"10_Porcine_MII_1_TAGCTT",
	"11_Porcine_MII_2_GGCTAC",
	"12_Porcine_GV_1_CTTGTA",
	"13_Porcine_GV_2_AGTCAA",
	"14_Bovine_ovary_1_AGTTCC",
	"15_Bovine_ovary_2_ATGTCA",
	"16_Bovine_testis_1_CAGATC",
	"17_Bovine_testis_2_ACTTGA",
	"18_Porcine_ovary_1_GTCCGC",
	"19_Porcine_ovary_2_GTGAAA",
	"20_Porcine_testis_1_GTGGCC",
	"21_Porcine_testis_2_GTTTCG",
	"22_Macaque_ovary_1_CGTACG",
	"23_Macaque_ovary_2_GAGTGG",
	"24_Macaque_testis_1_GGTAGC",
	"25_Macaque_testis_2_TTAGGC",
	"26_Bovine-cumulus-MI-1",
	"27_Bovine-cumulus-MI-2",
	"28_bovine_cumulus_MII_1_TTAGGC",
	"29_bovine_cumulus_MII_2_TGACCA",
	"30_porcine_cumulus_GV_1_ACAGTG",
	"31_porcine_cumulus_GV_2_GCCAAT",
	"32_porcine_GV_1_CAGATC",
	"33_porcine_GV_2_ACTTGA",
	"34_bovine_oxidized_1_GATCAG",
	"35_bovine_oxidized_2_TAGCTT",
	"36_macaque_oxidized_1_GGCTAC",
	"37_macaque_oxidized_2_CTTGTA",
	"38_bovine_IVF_1_AGTCAA",
	"39_bovine_IVF_2_AGTTCC",
	"40_human_ovary_1_ATGTCA",
	"41_human_ovary_2_CCGTCC",
	"42_human_ovary_1_oxidized_GTAGAG",
	"43_human_ovary_2_oxidized_GTCCGC",
	"44_fetal_1st_1_GTGAAA",
	"45_fetal_1st_2_GTGGCC",
	"46_fetal_1st_1_oxidized_GTTTCG",
	"47_fetal_1st_2_oxidized_CGTACG",
	"48_fetal_2nd_1_GAGTGG",
	"49_fetal_2nd_2_GGTAGC",
	"50_fetal_2nd_1_oxidized_ATCACG",
	"51_fetal_2nd_2_oxidized_CGATGT"
	);

$|=1;
open(OUT,">mismatch_plot.table")||die print $!;
open(OUT2,">nontemplate-ends.table")||die print $!;
foreach$probe(@probes)
	{
	%hits=();
	%plot=();
	%nontemplate_ends=();
	
	print".";
	open(IN,"$probe.passed.map")||die print $!;
	while(<IN>)
		{
		@d=split("\t",$_);
		$hits{$d[4]}++;
		}
	close IN;
	
	print"-";
	open(IN,"$probe.passed.map")||die print $!;
	while(<IN>)
		{
		@d=split("\t",$_);
		
		# mismatch plot
		foreach(19..length$d[4])
			{
			$pos=($_-length$d[4])-1;
			if(substr($d[4],$pos,1) ne substr($d[2],$pos,1))
				{
				$plot{$pos}{substr($d[4],$pos,1)}+=(1/$hits{$d[4]})*$d[3];
				}
			}
		
		# 3' end with 1 nt nontemplate
		if(substr($d[4],-1,1) ne substr($d[2],-1,1) && substr($d[4],-2,1) eq substr($d[2],-2,1))
			{
			$nontemplate_seq=substr($d[4],-1,1);
			$nontemplate_ends{$nontemplate_seq}+=(1/$hits{$d[4]})*$d[3];
			}
		
		# 3' end with 2 nt nontemplate
		elsif(substr($d[4],-1,1) ne substr($d[2],-1,1) && substr($d[4],-2,1) ne substr($d[2],-2,1) && substr($d[4],-3,1) eq substr($d[2],-3,1))
			{
			$nontemplate_seq=substr($d[4],-1,1);
			$nontemplate_seq.=substr($d[4],-2,1);
			$nontemplate_ends{$nontemplate_seq}+=(1/$hits{$d[4]})*$d[3];
			}
		
		# 3' end with 3 nt nontemplate
		elsif(substr($d[4],-1,1) ne substr($d[2],-1,1) && substr($d[4],-2,1) ne substr($d[2],-2,1) && substr($d[4],-3,1) ne substr($d[2],-3,1))
			{
			$nontemplate_seq=substr($d[4],-1,1);
			$nontemplate_seq.=substr($d[4],-2,1);
			$nontemplate_seq.=substr($d[4],-3,1);
			$nontemplate_ends{$nontemplate_seq}+=(1/$hits{$d[4]})*$d[3];
			}
		}
	close IN;
	
	print OUT"$probe\n";
	foreach$pos(-16..-1)
		{
		print OUT"$pos:\t";
		foreach$nuc('A','T','G','C','N')
			{
			print OUT"$nuc:$plot{$pos}{$nuc}\t";
			}
		print OUT"\n";
		}
	print OUT"\n";
	
	print OUT2"$probe\n";
	@nontemplate_ends=keys%nontemplate_ends;
	@nontemplate_ends=sort@nontemplate_ends;
	foreach$seq(@nontemplate_ends)
		{
		print OUT2"$seq\t$nontemplate_ends{$seq}\n";
		}
	print OUT"\n";
	
	undef%hits;
	undef%plot;
	undef%nontemplate_ends;
	}
close OUT;
close OUT2;