@probes=
	(
	#"1_Bovine_GV_a_ATCACG",
	#"2_Bovine_GV_b1_CGATGT",
	#"4_Bovine_MI_1_TGACCA",
	#"5_Bovine_MI_2_ACAGTG",
	#"6_Bovine_MII_a1_GCCAAT",
	#"7_Bovine_MII_a2_CCGTCC",
	#"8_Bovine_MII_b1_GTAGAG",
	#"9_Bovine_MII_b2_GATCAG",
	#"10_Porcine_MII_1_TAGCTT",
	#"11_Porcine_MII_2_GGCTAC",
	#"12_Porcine_GV_1_CTTGTA",
	#"13_Porcine_GV_2_AGTCAA",
	#"14_Bovine_ovary_1_AGTTCC",
	#"15_Bovine_ovary_2_ATGTCA",
	#"16_Bovine_testis_1_CAGATC",
	#"17_Bovine_testis_2_ACTTGA",
	"18_Porcine_ovary_1_GTCCGC",
	"19_Porcine_ovary_2_GTGAAA",
	#"20_Porcine_testis_1_GTGGCC",
	#"21_Porcine_testis_2_GTTTCG",
	#"22_Macaque_ovary_1_CGTACG",
	#"23_Macaque_ovary_2_GAGTGG",
	#"24_Macaque_testis_1_GGTAGC",
	#"25_Macaque_testis_2_TTAGGC",
	#"26_Bovine-cumulus-MI-1",
	#"27_Bovine-cumulus-MI-2",
	#"28_bovine_cumulus_MII_1_TTAGGC",
	#"29_bovine_cumulus_MII_2_TGACCA",
	#"30_porcine_cumulus_GV_1_ACAGTG",
	#"31_porcine_cumulus_GV_2_GCCAAT",
	#"32_porcine_GV_1_CAGATC",
	#"33_porcine_GV_2_ACTTGA",
	#"34_bovine_oxidized_1_GATCAG",
	#"35_bovine_oxidized_2_TAGCTT",
	#"36_macaque_oxidized_1_GGCTAC",
	#"37_macaque_oxidized_2_CTTGTA",
	#"38_bovine_IVF_1_AGTCAA",
	#"39_bovine_IVF_2_AGTTCC",
	#"40_human_ovary_1_ATGTCA",
	#"41_human_ovary_2_CCGTCC",
	#"42_human_ovary_1_oxidized_GTAGAG",
	#"43_human_ovary_2_oxidized_GTCCGC",
	#"44_fetal_1st_1_GTGAAA",
	#"45_fetal_1st_2_GTGGCC",
	#"46_fetal_1st_1_oxidized_GTTTCG",
	#"47_fetal_1st_2_oxidized_CGTACG",
	#"48_fetal_2nd_1_GAGTGG",
	#"49_fetal_2nd_2_GGTAGC",
	#"50_fetal_2nd_1_oxidized_ATCACG",
	#"51_fetal_2nd_2_oxidized_CGATGT"
	);

$norm_hits=1;	# normalize by number of genomic hits
$norm_reads=1;	# normalize by number of identical sequence reads
$min_input_length=18;
$max_input_length=34;



$|=1;
@childs=();
foreach$probe(@probes)
	{
	$pid=fork();
	if($pid) # parent
		{
		push(@childs,$pid);
		}
	elsif($pid==0) # child
		{
		# save genomic hits and reads for each sequence
		$eland3="$probe.passed.map";
		$max_length=0;
		$hits_plus=0;
		%hits_per_seq=();
		%reads_per_seq=();
		%all_seqs=();
		%pp_seqs=();
		open(IN,$eland3)||die print$!;
		print"Read $eland3...";
		while(<IN>)
			{
			if($_!~/^trans_id/)
				{
				@d=split("\t",$_);
				
				# skip sequence if it is outside the length range
				if(length$d[4]<$min_input_length||length$d[4]>$max_input_length)
					{
					next;
					}
				
				if($d[6]=~/\+/)
					{
					$hits_plus++;
					}
				if($norm_hits==1)
					{
					$hits_per_seq{$d[4]}++;
					}
				else
					{
					$hits_per_seq{$d[4]}=1;
					}
				if($norm_reads==1)
					{
					$reads_per_seq{$d[4]}=$d[3];
					}
				else
					{
					$reads_per_seq{$d[4]}=1;
					}
				if(length$d[4]>$max_length) # save max. sequence length (-> maximum overlap)
					{
					$max_length=length$d[4];
					}
				}
			}
		close IN;
		print" done.\nHits on the plus strand: $hits_plus\n";

		# read map with sliding window
		@sw=();
		%overlap=();
		$prev_loc='';
		$processed_plus=0;
		open(IN,$eland3)||die print$!;
		while(<IN>)
			{
			if($_!~/^trans_id/)
				{
				@d=split("\t",$_);
				
				# skip sequence if it is outside the length range
				if(length$d[4]<$min_input_length||length$d[4]>$max_input_length)
					{
					next;
					}
				
				$all_seqs{$d[4]}=$reads_per_seq{$d[4]};
				
				if($d[0]ne$prev_loc) # empty sliding window when location changes
					{
					@sw=();
					}
				if($d[6]=~/-/) # add hit to sliding window if current hit is on the minus strand
					{
					push(@sw,[$d[1],$d[4]]); # sliding window entries comprise coordinate|sequence
					while(1) # check if hit(s) must be removed from sliding window
						{
						if(@sw>1&&$d[1]>($sw[0][0])+$max_length)
							{
							shift@sw;
							}
						else
							{
							last;
							}
						}
					}
				else # count overlaps in the sliding window if current hit is on the plus strand
					{
					foreach$i(0..@sw-1)
						{
						if($sw[$i][0]+(length$sw[$i][1])>$d[1]&&$sw[$i][0]+(length$sw[$i][1])<$d[1]+length$d[4]) # check whether hits overlap
							{
							$overlap{$sw[$i][0]+(length$sw[$i][1])-$d[1]}+=($reads_per_seq{$d[4]}/$hits_per_seq{$d[4]})*($reads_per_seq{$sw[$i][1]}/$hits_per_seq{$sw[$i][1]});
							
							# save 10bp overlapping sequences
							if($sw[$i][0]+(length$sw[$i][1])-$d[1]==10)
								{
								$pp_seqs{$sw[$i][1]}=$reads_per_seq{$sw[$i][1]};
								$pp_seqs{$d[4]}=$reads_per_seq{$d[4]};
								}
							}
						}
					$processed_plus++;
					if($processed_plus=~/0000$/)
						{
						print".";
						}
					}
				$prev_loc=$d[0];
				}
			}
		close IN;
		
		open(OUT,">$probe.pp$min_input_length-$max_input_length")||die print$!;
		print"\n";
		foreach(1..$max_length)
			{
			print"$_\t$overlap{$_}\n";
			print OUT"$_\t$overlap{$_}\n";
			}
		
		$all_reads=0;
		$pp_reads=0;
		$all_seqs=keys%all_seqs;
		$pp_seqs=keys%pp_seqs;
		foreach(keys%all_seqs)
			{
			$all_reads+=$all_seqs{$_};
			}
		foreach(keys%pp_seqs)
			{
			$pp_reads+=$pp_seqs{$_};
			}
		
		print OUT"\nall reads (sequences): $all_reads ($all_seqs)\npp reads (sequences): $pp_reads ($pp_seqs)";
		close OUT;
		
		exit 0;
		}
	else
		{
		die"could not fork: $!\n";
		}
	}
foreach(@childs)
	{
	$tmp=waitpid($_,0);
	}
